package oop;

import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.*;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;

public class MõistatusePaan extends StackPane{
    private StackPane paan;

    public MõistatusePaan(){
        this.paan = new StackPane();
    }

    public Nupp kujundaCaesariNihe(double eelnevLaius, double eelnevKõrgus, BackgroundImage pilt){
        this.setPadding(new Insets(0,0,40,0));
        this.setPrefSize(eelnevLaius, eelnevKõrgus);
        this.setBackground(new Background(pilt));
        TextField vastuseKast = new TextField();
        vastuseKast.setOnMouseClicked(me -> vastuseKast.setText(""));

        Nupp okNupp = new Nupp();
        okNupp.kujunda("Sisesta vastus");
        Nupp tagasi = new Nupp();
        tagasi.kujunda("Mine tagasi");

        Label tagasiside = new Label("");
        tagasiside.setTextFill(Color.MAROON);
        tagasiside.setFont(Font.font("Verdana", FontWeight.BOLD, 12));
        HBox lahtrid = new HBox();
        VBox siltNupud15 = new VBox();
        siltNupud15.setSpacing(20);
        siltNupud15.setAlignment(Pos.BOTTOM_CENTER);
        lahtrid.setAlignment(Pos.BOTTOM_CENTER);
        lahtrid.getChildren().addAll(vastuseKast, okNupp, tagasi);
        siltNupud15.getChildren().addAll(tagasiside,lahtrid);
        this.getChildren().add(siltNupud15);

        okNupp.setOnAction(event_vastus_sisestatud -> {
            String sisestus = vastuseKast.getText();
            if (sisestus.equals("2001")) {
                tagasiside.setText("Ja tuli ära õige vastus, jäta see meelde ja mine vaata, mis sul veel teha vaja on, enne kui saad lahkuda.");
            } else {
                tagasiside.setText("Vale vastus! Proovi uuesti.");
            }
        });
        return tagasi;
    }

    public Nupp kujundaMaatriks(double eelnevLaius, double eelnevKõrgus, BackgroundImage pilt){
        this.setPadding(new Insets(0,0,40,0));
        this.setPrefSize(eelnevLaius, eelnevKõrgus);
        this.setBackground(new Background(pilt));
        TextField vastuseKast = new TextField();
        vastuseKast.setOnMouseClicked(me -> vastuseKast.setText(""));

        Nupp okNupp = new Nupp();
        okNupp.kujunda("Sisesta vastus");
        Nupp tagasi = new Nupp();
        tagasi.kujunda("Mine tagasi");

        Label tagasiside = new Label("");
        tagasiside.setTextFill(Color.MAROON);
        tagasiside.setFont(Font.font("Verdana", FontWeight.BOLD, 12));
        HBox lahtrid = new HBox();
        VBox siltNupud14 = new VBox();
        siltNupud14.setAlignment(Pos.BOTTOM_CENTER);
        siltNupud14.setSpacing(20);
        lahtrid.setAlignment(Pos.BOTTOM_CENTER);
        lahtrid.getChildren().addAll(vastuseKast, okNupp, tagasi);
        siltNupud14.getChildren().addAll(tagasiside, lahtrid);
        this.getChildren().add(siltNupud14);

        okNupp.setOnAction(event_vastus_sisestatud -> {
            String sisestus = vastuseKast.getText();
            if (sisestus.equals("420")) {
                tagasiside.setText("Läkski täppi, jäta vastus meelde ja mine vaata, kas midagi on vaja veel teha enne, kui siit lõpuks välja saad.");
            } else {
                tagasiside.setText("Vale vastus! Proovi uuesti.");
            }
        });
        return tagasi;
    }

    public Nupp kujundaRuut(double eelnevLaius, double eelnevKõrgus, BackgroundImage pilt){
        this.setPadding(new Insets(0,0,40,0));
        this.setPrefSize(eelnevLaius, eelnevKõrgus);
        this.setBackground(new Background(pilt));
        TextField vastuseKast3 = new TextField();
        vastuseKast3.setOnMouseClicked(me -> vastuseKast3.setText(""));

        Nupp okNupp12 = new Nupp();
        okNupp12.kujunda("Sisesta vastus");
        Nupp tagasi5 = new Nupp();
        tagasi5.kujunda("Mine tagasi");

        Label tagasiside12 = new Label("");
        tagasiside12.setTextFill(Color.MAROON);
        tagasiside12.setFont(Font.font("Verdana", FontWeight.BOLD, 12));
        HBox lahtrid3 = new HBox();
        VBox siltNupud32 = new VBox();
        siltNupud32.setAlignment(Pos.BOTTOM_CENTER);
        siltNupud32.setSpacing(20);
        lahtrid3.setAlignment(Pos.BOTTOM_CENTER);
        lahtrid3.getChildren().addAll(vastuseKast3, okNupp12, tagasi5);
        siltNupud32.getChildren().addAll(tagasiside12, lahtrid3);
        this.getChildren().add(siltNupud32);

        okNupp12.setOnAction(event_vastus_sisestatud -> {
            String sisestus2 = vastuseKast3.getText();
            if (sisestus2.equals("5614")){
                tagasiside12.setText("See läks täppi õnneks. Jäta see           \nvastus meelde ja mine vaata,          \nkas on vaja veel midagi teha.         ");
            }else{
                tagasiside12.setText("Vale vastus! Proovi uuesti.       ");
            }
        });
        return tagasi5;
    }

    public Nupp kujundaTabel(double eelnevLaius, double eelnevKõrgus, BackgroundImage pilt){
        this.setPadding(new Insets(0,0,40,0));
        this.setPrefSize(eelnevLaius, eelnevKõrgus);
        this.setBackground(new Background(pilt));
        TextField vastuseKast3 = new TextField();
        vastuseKast3.setOnMouseClicked(me -> vastuseKast3.setText(""));

        Nupp okNupp1 = new Nupp();
        okNupp1.kujunda("Sisesta vastus");
        Nupp tagasi4 = new Nupp();
        tagasi4.kujunda("Mine tagasi");

        Label tagasiside1 = new Label("");
        tagasiside1.setTextFill(Color.MAROON);
        tagasiside1.setFont(Font.font("Verdana", FontWeight.BOLD, 12));
        HBox lahtrid3 = new HBox();
        VBox siltNupud3 = new VBox();
        siltNupud3.setAlignment(Pos.BOTTOM_CENTER);
        siltNupud3.setSpacing(20);
        lahtrid3.setAlignment(Pos.BOTTOM_CENTER);
        lahtrid3.getChildren().addAll(vastuseKast3, okNupp1, tagasi4);
        siltNupud3.getChildren().addAll(tagasiside1, lahtrid3);
        this.getChildren().add(siltNupud3);

        okNupp1.setOnAction(event_vastus_sisestatud -> {
            String sisestus2 = vastuseKast3.getText();
            if (sisestus2.equals("8332")){
                tagasiside1.setText("Said õigele lahendusele pihta, jäta vastus meelde ja vaata, mis veel tegema pead, enne kui saad lahkuda.");
            }else{
                tagasiside1.setText("Vale vastus! Proovi uuesti.");
            }
        });
        return tagasi4;
    }
}
