package oop;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.image.Image;
import javafx.scene.input.KeyEvent;
import javafx.scene.layout.*;
import javafx.scene.paint.Color;
import javafx.scene.paint.Paint;
import javafx.scene.shape.Circle;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.stage.Stage;

import java.io.*;
import java.security.Timestamp;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import static javafx.scene.text.TextAlignment.CENTER;

public class Põgenemistuba extends Application {
    public static void main(String[] args)  {
        launch(args);
    }

    public void start(Stage peaLava) {
        // MENÜÜ
        StackPane juur = new StackPane();
        // Taustapildi seadmise kood osaliselt võetud siit: https://stackoverflow.com/questions/9738146/javafx-how-to-set-scene-background-image
        // Pildi allikas: https://cdnb.artstation.com/p/assets/images/images/008/726/483/large/shubham-tak-final-with-dirt-1.jpg?1514907779
        BackgroundImage taustapilt = new BackgroundImage(new Image("file:avalehtfailina.jpg", 1015, 571, true, true),
                BackgroundRepeat.NO_REPEAT, BackgroundRepeat.NO_REPEAT, BackgroundPosition.CENTER,
                BackgroundSize.DEFAULT);
        juur.setBackground(new Background(taustapilt)); // Seatakse menüüaknale taustapilt
        juur.setPadding(new Insets(100, 100, 100, 100));
        juur.setPrefSize(1015, 571);

        Label pealkiri = new Label("PÕGENEMISTUBA"); // Seatakse menüüaknale pealkiri
        pealkiri.setFont(Font.font("Verdana", FontWeight.MEDIUM, 30)); // Teksti kujundamine
        pealkiri.setTextFill(Color.ANTIQUEWHITE);
        pealkiri.setAlignment(Pos.CENTER);
        pealkiri.setTextAlignment(CENTER);
        pealkiri.setPrefSize(300, 100);

        // Luuakse menüü nupud: alusta mängu, sissejuhatus ja välju; nupud kujundatakse
        Nupp nupp1 = new Nupp();
        nupp1.kujundaMenüüNupp("ALUSTA MÄNGU");
        Nupp nupp2 = new Nupp();
        nupp2.kujundaMenüüNupp("SISSEJUHATUS");
        Nupp nupp3 = new Nupp();
        nupp3.kujundaMenüüNupp("VÄLJU");

        VBox nupud = new VBox(); // Pealkiri ja nupud pannakse vbox-i, mis lisatakse juurele
        nupud.setAlignment(Pos.CENTER);
        nupud.setSpacing(30);
        nupud.getChildren().addAll(pealkiri, nupp1, nupp2, nupp3);
        juur.getChildren().add(nupud);
        juur.setAlignment(nupud, Pos.CENTER);

        // MÄNG
        nupp1.setOnMouseClicked(event_menüüst_mängu -> { // Avaneb mängu enda aken
            long algushetk = System.currentTimeMillis(); // Selleks et lõpus mängitud aega arvestada, jäädvustatakse mängu alustamise hetk

            // Luuakse mitu pildi isendit, et neid hiljem taustaks seada
            // Pildi allikas: https://scarina.files.wordpress.com/2012/10/computers.jpg
            BackgroundImage algusPilt = new BackgroundImage(new Image("file:Arvutikaugeltfailina.jpg", 1050, 561, true, true),
                    BackgroundRepeat.NO_REPEAT, BackgroundRepeat.NO_REPEAT, BackgroundPosition.CENTER,
                    BackgroundSize.DEFAULT);
            // Pildi allikas: https://i.imgur.com/iawEIhw.jpg
            BackgroundImage uksePilt = new BackgroundImage(new Image("file:uksekoodfailina.jpg", 923, 566, true, true),
                    BackgroundRepeat.NO_REPEAT, BackgroundRepeat.NO_REPEAT, BackgroundPosition.CENTER,
                    BackgroundSize.DEFAULT);
            // Pildi allikas: https://i.imgur.com/Y5QsNw1.png
            BackgroundImage maatriksPilt = new BackgroundImage(new Image("file:maatriksfailina.png", 923, 566, true, true),
                    BackgroundRepeat.NO_REPEAT, BackgroundRepeat.NO_REPEAT, BackgroundPosition.CENTER,
                    BackgroundSize.DEFAULT);
            // Pildi allikas: https://i.imgur.com/b6p3iCw.png
            BackgroundImage CaesarPilt = new BackgroundImage(new Image("file:caesarfailina.png", 923, 566, true, true),
                    BackgroundRepeat.NO_REPEAT, BackgroundRepeat.NO_REPEAT, BackgroundPosition.CENTER,
                    BackgroundSize.DEFAULT);
            // Pildi allikas: https://i.imgur.com/SNCB3np.png
            BackgroundImage RuutPilt = new BackgroundImage(new Image("file:maagilineruutfailina.png", 923, 566, true, true),
                    BackgroundRepeat.NO_REPEAT, BackgroundRepeat.NO_REPEAT, BackgroundPosition.CENTER,
                    BackgroundSize.DEFAULT);
            // Pildi allikas: https://i.imgur.com/qOIdK80.png
            BackgroundImage numbritePilt = new BackgroundImage(new Image("file:arvudetabelfailina.png", 923, 566, true, true),
                    BackgroundRepeat.NO_REPEAT, BackgroundRepeat.NO_REPEAT, BackgroundPosition.CENTER,
                    BackgroundSize.DEFAULT);

            StackPane mänguPaan = new StackPane(); // Luuakse uus paan mängu jaoks
            mänguPaan.setBackground(new Background(algusPilt)); // seatakse taustapilt
            mänguPaan.setPadding(new Insets(200, 100, 100, 100)); // Regulaaritakse taustapildi kujundust
            mänguPaan.setPrefSize(1050, 561);
            Scene mänguStseen = new Scene(mänguPaan, 1050,561); // Luuakse uus stseen
            Stage mänguLava = new Stage(); // Luuakse mängu jaoks lava
            mänguLava.setMaxWidth(1050);
            mänguLava.setMaxHeight(561);
            mänguLava.setScene(mänguStseen);
            mänguLava.setTitle("Mängu sisu");
            VBox siltNupp = new VBox(); // ekraanil oleva teksti ja nupu jaoks luuakse vbox
            siltNupp.setAlignment(Pos.CENTER);
            siltNupp.setSpacing(30.0);
            Label näedArvutitTekst = new Label("Näed toa nurgas arvutit.");
            // Tekstielementide kujundus
            näedArvutitTekst.setTextFill(Color.FLORALWHITE);
            näedArvutitTekst.setFont(Font.font("Verdana",16));
            Button arvutiJuurde = new Button("MINE ARVUTI JUURDE");
            arvutiJuurde.setFont(Font.font("Verdana",FontWeight.MEDIUM,16));
            arvutiJuurde.setTextFill(Color.FLORALWHITE);
            arvutiJuurde.setStyle("-fx-background-color: #000000; -fx-border-width: 2px; -fx-border-color: #DEB887;  -fx-border-radius: 10px");
            siltNupp.getChildren().addAll(näedArvutitTekst,arvutiJuurde);
            mänguPaan.getChildren().add(siltNupp);

            // Nupu kujundus jällegi muutub, kui hiirega siseneda
            arvutiJuurde.setOnMouseEntered(me->{
                arvutiJuurde.setTextFill(Color.BLACK);
                arvutiJuurde.setStyle("-fx-background-color: #FFFAF0; -fx-background-radius: 10px; -fx-border-width: 2px; -fx-border-color: #A0522D;  -fx-border-radius: 10px");
            });

            arvutiJuurde.setOnMouseExited(me->{
                arvutiJuurde.setTextFill(Color.FLORALWHITE);
                arvutiJuurde.setStyle("-fx-background-color: #000000; -fx-border-width: 2px; -fx-border-color: #DEB887;  -fx-border-radius: 10px");
            });

            // ARVUTI SISSEJUHATUS
            arvutiJuurde.setOnMouseClicked(event_arvuti_juurde -> { // Avatakse mängu sissejuhatav stseen
                double eelnevLaius = mänguPaan.getWidth(); // Akna suurus võetakse üle eelmisest paanist
                double eelnevKõrgus = mänguPaan.getHeight();
                StackPane arvutiSissejuhatus = new StackPane();
                // Pildi allikas: https://fossbytes.com/wp-content/uploads/2016/10/commodore64-768x427.jpg
                BackgroundImage arvutiPilt = new BackgroundImage(new Image("file:rohelinearvutifailina.jpg", 923, 566, true, true),
                        BackgroundRepeat.NO_REPEAT, BackgroundRepeat.NO_REPEAT, BackgroundPosition.CENTER,
                        BackgroundSize.DEFAULT);
                arvutiSissejuhatus.setBackground(new Background(arvutiPilt));
                arvutiSissejuhatus.setPadding(new Insets(100, 100, 100, 100));
                arvutiSissejuhatus.setPrefSize(eelnevLaius, eelnevKõrgus);
                Scene asjStseen = new Scene(arvutiSissejuhatus, eelnevLaius,eelnevKõrgus);
                asjStseen.setFill(Color.BLACK);
                mänguLava.setScene(asjStseen); // Mängu laval vahetatakse stseen
                Button enter = new Button();
                Label silt = new Label("Leiad toa nurgast arvuti, ekraanil ainult silt: Vajuta Enter!");
                silt.setFont(Font.font("Verdana",FontWeight.MEDIUM,14));
                silt.setTextFill(Color.FLORALWHITE);
                enter.setStyle("-fx-background-color: null");
                Label tekstiTaust1 = new Label();
                tekstiTaust1.setPadding(new Insets(20,20,20,20));
                tekstiTaust1.setPrefSize(900,120);
                tekstiTaust1.setStyle("-fx-background-color: #000000;");
                tekstiTaust1.setOpacity(0.7);
                arvutiSissejuhatus.getChildren().addAll(tekstiTaust1, silt,enter);
                enter.setOnKeyPressed(event_arvutile_juhised -> { // Ekraanile ilmuvad juhised pärast Enteri vajutamist
                    silt.setText("*ilmub tekst* Ma loodan, et tead, miks siin oled ja mida tegema pead, siiski juhiste nägemiseks võid vajutada ENTER!");
                    // ESIMENE TUBA
                    enter.setOnKeyPressed(event_esimesse_tuppa -> { // Pärast Enteri vajutamist sisenetakse esimesse tuppa
                        double eelnevLaius2 = arvutiSissejuhatus.getWidth();
                        double eelnevKõrgus2 = arvutiSissejuhatus.getHeight();
                        StackPane tuba1 = new StackPane();
                        tuba1.setPadding(new Insets(0,0,20,0));
                        HBox nupud1 = new HBox();
                        nupud1.setAlignment(Pos.BOTTOM_CENTER);
                        tuba1.setBackground(new Background(taustapilt));
                        tuba1.setPadding(new Insets(100, 100, 100, 100));
                        tuba1.setPrefSize(eelnevLaius2, eelnevKõrgus2);
                        // Tuppa luuakse nupud ja need kujundatakse
                        Nupp otse = new Nupp();
                        otse.kujunda("Mine ukse juurde!");
                        Nupp vasakule = new Nupp();
                        vasakule.kujunda("Vaata, mis on vasakul seinal!");
                        Nupp paremale = new Nupp();
                        paremale.kujunda("Vaata, mis on paremal seinal!");

                        nupud1.getChildren().addAll(otse, vasakule, paremale);
                        tuba1.getChildren().add(nupud1);
                        Scene tuba1Stseen = new Scene(tuba1, eelnevLaius2,eelnevKõrgus2);
                        tuba1Stseen.setFill(Color.BLACK);
                        mänguLava.setScene(tuba1Stseen); // Mängulaval vahetatakse stseeni
                        // UKS
                        otse.setOnMouseClicked(event_esimese_ukse_juurde -> { // Minnakse ukse juurde
                            double eelnevLaius3 = tuba1.getWidth();
                            double eelnevKõrgus3 = tuba1.getHeight();
                            StackPane uks = new StackPane();
                            uks.setPadding(new Insets(0,0,40,0));
                            uks.setPrefSize(eelnevLaius3, eelnevKõrgus3);
                            TextField uksekood = new TextField();
                            uks.setBackground(new Background(uksePilt));
                            uksekood.setOnMouseClicked(me -> uksekood.setText(""));
                            // Luuakse nupud uksekoodi sisestamiseks ja tagasisideks ja need kujundatakse
                            Nupp okNupp = new Nupp();
                            okNupp.kujunda("Sisesta kood");
                            Nupp tagasi = new Nupp();
                            tagasi.kujunda("Mine tagasi");
                            Nupp teiseTuppa = new Nupp();
                            teiseTuppa.kujunda("Õige kood, mine edasi!");

                            Label tagasiside = new Label(""); // Luuakse silt vastuse tagasisidestamiseks
                            tagasiside.setTextFill(Color.FLORALWHITE);
                            tagasiside.setFont(Font.font("Verdana", FontWeight.MEDIUM,12));
                            HBox nupud21 = new HBox();
                            VBox siltNupud21 = new VBox();
                            siltNupud21.setAlignment(Pos.BOTTOM_CENTER);
                            siltNupud21.setSpacing(20.0);
                            nupud21.setAlignment(Pos.BOTTOM_CENTER);
                            nupud21.getChildren().addAll(uksekood, okNupp, tagasi);
                            siltNupud21.getChildren().addAll(tagasiside, nupud21);
                            uks.getChildren().add(siltNupud21);
                            Scene ukseStseen = new Scene(uks, eelnevLaius3, eelnevKõrgus3);
                            ukseStseen.setFill(Color.BLACK);
                            mänguLava.setScene(ukseStseen); // Mängu laval vahetatakse stseeni
                            okNupp.setOnAction(event_vastus_sisestatud -> {
                                int vastus = 0;
                                String sisestus = uksekood.getText();
                                try{ // Kui tekstikasti üritatakse sisestada midagi muud kui numbreid, siis hoiatatakse kasutajat.
                                    vastus = Integer.parseInt(sisestus);
                                    if (vastus == 4202001) {
                                        tagasiside.setText("");
                                        nupud21.getChildren().add(teiseTuppa); // Kui kasutaja sisestab õige uksekoodi, siis ilmub nupp teise tuppa pääsemiseks
                                    }
                                    else{
                                        tagasiside.setText("Vale vastus! Proovi uuesti.");
                                    }
                                } catch (NumberFormatException nfe){
                                        tagasiside.setText("Vastus võib sisaldada vaid numbreid.");
                                }
                            });
                            // TEINE TUBA
                            teiseTuppa.setOnMouseClicked(event_teise_tuppa -> { // Minnakse teise tuppa
                                double eelnevLaius4 = uks.getWidth();
                                double eelnevKõrgus4 = uks.getHeight();
                                StackPane tuba2 = new StackPane();
                                tuba2.setPadding(new Insets(0,0,40,0));
                                tuba2.setPrefSize(eelnevLaius4, eelnevKõrgus4);
                                // Pildi allikas: https://image.freepik.com/free-photo/horror-creepy-damage-empty-room_307211-168.jpg
                                BackgroundImage teineTubaPilt = new BackgroundImage(new Image("file:teinetubafailina.jpg", 923, 566, true, true),
                                        BackgroundRepeat.REPEAT, BackgroundRepeat.REPEAT, BackgroundPosition.CENTER,
                                        BackgroundSize.DEFAULT);
                                tuba2.setBackground(new Background(teineTubaPilt));
                                Scene tuba2Stseen = new Scene(tuba2, eelnevLaius4, eelnevKõrgus4);
                                tuba2Stseen.setFill(Color.BLACK);
                                Label tuba2Tekst = new Label ("Kas te teete nalja minuga? Ma mõtlesin, et pääsen juba siit, kuid siin on veel üks tuba?... \nAnnaks praegu kõik, et olla kuskil mujal - pere juures ehk... \nKuid sul ei ole pikalt aega mõtled endamisi, filmidest tead, et kui sa siit kiiremas korras ei pääse, siis on sinu lips läbi... \nAsud uuesti väljapääsu otsima...");
                                tuba2Tekst.setTextFill(Color.FLORALWHITE);
                                tuba2Tekst.setFont(Font.font("Verdana", FontWeight.MEDIUM, 14));
                                Label tekstiTaust = new Label();
                                tekstiTaust.setPadding(new Insets(20,20,20,20));
                                tekstiTaust.setPrefSize(900,200);
                                tekstiTaust.setStyle("-fx-background-color: #000000");
                                tekstiTaust.setOpacity(0.7);
                                tuba2.getChildren().addAll(tekstiTaust,tuba2Tekst);
                                HBox nupud3 = new HBox();
                                nupud3.setAlignment(Pos.BOTTOM_CENTER);
                                // Luuakse nupud ja kujundatakse need
                                Nupp otse2 = new Nupp();
                                otse2.kujunda("Mine otse!");
                                Nupp vasakule2 = new Nupp();
                                vasakule2.kujunda("Vaata, mis toimub vasakul");
                                Nupp paremale2 = new Nupp();
                                paremale2.kujunda("Vaata, mis toimub paremal");

                                nupud3.getChildren().addAll(otse2, vasakule2, paremale2);
                                tuba2.getChildren().add(nupud3);
                                mänguLava.setScene(tuba2Stseen);
                                // TEINE UKS
                                otse2.setOnMouseClicked(event_teise_ukse_juurde -> { // Minnakse teise ukse juurde
                                    double eelnevLaius5 = tuba2.getWidth();
                                    double eelnevKõrgus5 = tuba2.getHeight();
                                    StackPane uks2 = new StackPane();
                                    uks2.setPadding(new Insets(0,0,40,0));
                                    uks2.setPrefSize(eelnevLaius5, eelnevKõrgus5);
                                    uks2.setBackground(new Background(uksePilt));
                                    TextField uksekood2 = new TextField();
                                    uksekood2.setOnMouseClicked(me -> uksekood2.setText(""));
                                    Label tagasiside2 = new Label("");
                                    tagasiside2.setTextFill(Color.FLORALWHITE);
                                    tagasiside2.setFont(Font.font("Verdana", FontWeight.MEDIUM,12));
                                    // Luuakse nupud vastuse sisestamiseks ja kujundatakse need
                                    Nupp okNupp2 = new Nupp();
                                    okNupp2.kujunda("Sisesta vastus");
                                    Nupp tagasi3 = new Nupp();
                                    tagasi3.kujunda("Mine tagasi");
                                    Nupp välja = new Nupp();
                                    välja.kujunda("Lahku sellest majast!");

                                    HBox nupud31 = new HBox();
                                    VBox siltNupud31 = new VBox();
                                    siltNupud31.setSpacing(20);
                                    siltNupud31.setAlignment(Pos.BOTTOM_CENTER);
                                    nupud31.setAlignment(Pos.BOTTOM_CENTER);
                                    nupud31.getChildren().addAll(uksekood2, okNupp2,tagasi3);
                                    siltNupud31.getChildren().addAll(tagasiside2, nupud31);
                                    uks2.getChildren().add(siltNupud31);
                                    Scene ukse2Stseen = new Scene(uks2, eelnevLaius5, eelnevKõrgus5);
                                    ukse2Stseen.setFill(Color.BLACK);
                                    mänguLava.setScene(ukse2Stseen); // mängu laval vahetatakse stseeni
                                    okNupp2.setOnAction(event_vastus_sisestatud -> {
                                        String sisestus2 = uksekood2.getText();
                                        try{ // Kui kasutaja üritab uksekoodiks sisestada midagi muud kui numbreid, siis hoiatatakse teda
                                            int vastus2 = Integer.parseInt(sisestus2);
                                            if (vastus2 == 83325614) {
                                                tagasiside2.setText("");
                                                nupud31.getChildren().add(välja); // Kui kasutaja sisestab õige vastuse, siis ilmub nupp välja pääsemiseks
                                            }
                                            else{
                                                tagasiside2.setText("Vale vastus! Proovi uuesti.");
                                            }
                                        } catch (NumberFormatException nfe){
                                            tagasiside2.setText("Vastus võib sisaldada vaid numbreid.");
                                        }
                                    });
                                    // LÕPUSTSEEN
                                    välja.setOnMouseClicked(event_mängu_lõppu -> { // Jõutakse mängu lõpuni
                                        long lõpphetk = System.currentTimeMillis(); // Jäädvustatakse mängu lõpetamise hetk
                                        double eelnevLaius6 = uks2.getWidth();
                                        double eelnevKõrgus6 = uks2.getHeight();
                                        StackPane lõpp = new StackPane();
                                        lõpp.setPrefSize(eelnevLaius6, eelnevKõrgus6);
                                        // Pildi allikas: https://besthqwallpapers.com/Uploads/31-5-2018/54650/thumb2-tall-trees-pine-needles-forest-usa-bottom-view.jpg
                                        BackgroundImage loppPilt = new BackgroundImage(new Image("file:metsfailina.jpg", 923, 566, true, true),
                                                BackgroundRepeat.REPEAT, BackgroundRepeat.REPEAT, BackgroundPosition.CENTER,
                                                BackgroundSize.DEFAULT);
                                        lõpp.setBackground(new Background(loppPilt));
                                        Scene lõpuStseen = new Scene(lõpp, eelnevLaius6,eelnevKõrgus6);
                                        lõpuStseen.setFill(Color.BLACK);
                                        // Arvutatakse välja mängimisele kulunud aeg
                                        int tunnid = (int)((lõpphetk-algushetk)*0.001*(1.0/3600));
                                        int minutid = (int)((lõpphetk-algushetk-tunnid*3600*1000)*0.001*(1.0/60));
                                        int sekundid = (int)((lõpphetk-algushetk-tunnid*3600*1000-minutid*60*1000)*0.001);
                                        String kulunudAeg = tunnid + " tundi " + minutid + " minutit " + sekundid + " sekundit";
                                        int koht = lisaFaili(lõpphetk, algushetk); // Kulunud aeg lisatakse faili, kus on kõigi eelnevate mängijate ajad ning tagastatakse mängija koht edetabelis
                                        Label lõputeade = new Label("Jõuad lõpuks sellest jubedast majast välja, kuid midagi on valesti... \nSul pole õrna aimu ka, kus sa oled...\nMõtled endamisi, et küllap on see siis alles sinu seikluse algus ning asud teele suvalises suunas... \n \n \nMängu lõpp! Sul kulus " + kulunudAeg + "." +
                                                "\nEdetabelis oled " + koht + ". kohal");
                                        lõputeade.setTextFill(Color.FLORALWHITE);
                                        lõputeade.setFont(Font.font("Verdana", FontWeight.MEDIUM, 14));
                                        Label tekstikast = new Label();
                                        tekstikast.setPadding(new Insets(20,20,20,20));
                                        tekstikast.setPrefSize(900,200);
                                        tekstikast.setStyle("-fx-background-color: #000000");
                                        tekstikast.setOpacity(0.8);
                                        lõpp.getChildren().addAll(tekstikast,lõputeade); // Ekraanile ilmub lõputeade
                                        mänguLava.setScene(lõpuStseen);
                                    });
                                    tagasi3.setOnMouseClicked(event_tagasi_teise_tuppa -> { // Naastakse teise toa stseeni
                                        double eelnevLaius11 = mänguLava.getWidth();
                                        double eelnevKõrgus11 = mänguLava.getHeight();
                                        mänguLava.setScene(tuba2Stseen);
                                    });
                                });
                                // ARVUDE TABEL
                                vasakule2.setOnMouseClicked(event_numbritabeli_juurde -> { // Minnakse arvude tabeli ülesande juurde
                                    double eelnevLaius7 = tuba2.getWidth();
                                    double eelnevKõrgus7 = tuba2.getHeight();
                                    MõistatusePaan tabel = new MõistatusePaan();
                                    Nupp tagasi4 = tabel.kujundaTabel(eelnevLaius7, eelnevKõrgus7, numbritePilt);
                                    Scene tabeliStseen = new Scene(tabel, eelnevLaius7, eelnevKõrgus7);
                                    tabeliStseen.setFill(Color.BLACK);
                                    mänguLava.setScene(tabeliStseen);
                                    tagasi4.setOnAction(event_tagasi_teise_tuppa -> mänguLava.setScene(tuba2Stseen)); // Minnakse tagasi teise toa stseeni
                                });
                                // MAAGILINE RUUT
                                paremale2.setOnMouseClicked(event_maagilise_ruudu_juurde -> { // Minnakse maagilise ruudu ülesande juurde
                                    double eelnevLaius8 = tuba2.getWidth();
                                    double eelnevKõrgus8 = tuba2.getHeight();
                                    MõistatusePaan ruut = new MõistatusePaan();
                                    Nupp tagasi5 = ruut.kujundaRuut(eelnevLaius8, eelnevKõrgus8, RuutPilt);
                                    Scene ruuduStseen = new Scene(ruut, eelnevLaius8, eelnevKõrgus8);
                                    ruuduStseen.setFill(Color.BLACK);
                                    mänguLava.setScene(ruuduStseen);
                                    tagasi5.setOnAction(event_tagasi_teise_tuppa -> mänguLava.setScene(tuba2Stseen)); // Minnakse tagasi teise toa stseeni
                                });
                            });
                            tagasi.setOnMouseClicked(event_tagasi_esimesse_tuppa -> mänguLava.setScene(tuba1Stseen)); // Minnakse tagasi esimese toa stseeni
                        });
                        // MAATRIKS
                        vasakule.setOnMouseClicked(event_maatriksi_juurde -> { // Minnakse maatriksi ülesande juurde
                            double eelnevLaius9 = tuba1.getWidth();
                            double eelnevKõrgus9 = tuba1.getHeight();
                            MõistatusePaan maatriks = new MõistatusePaan();
                            Nupp tagasi = maatriks.kujundaMaatriks(eelnevLaius9, eelnevKõrgus9, maatriksPilt);
                            Scene maatriksiStseen = new Scene(maatriks, eelnevLaius9, eelnevKõrgus9);
                            maatriksiStseen.setFill(Color.BLACK);
                            mänguLava.setScene(maatriksiStseen);
                            tagasi.setOnAction(event_tagasi_esimesse_tuppa -> mänguLava.setScene(tuba1Stseen)); // Minnakse tagasi esimese toa stseeni
                        });
                        // CAESARI NIHE
                        paremale.setOnMouseClicked(event_caesari_nihke_juurde -> { // Minnakse caesari nihke ülesande juurde
                            double eelnevLaius10 = tuba1.getWidth();
                            double eelnevKõrgus10 = tuba1.getHeight();
                            MõistatusePaan caesariNihe = new MõistatusePaan();
                            Nupp tagasi = caesariNihe.kujundaCaesariNihe(eelnevLaius10,eelnevKõrgus10,CaesarPilt);
                            Scene caesariStseen = new Scene(caesariNihe, eelnevLaius10, eelnevKõrgus10);
                            caesariStseen.setFill(Color.BLACK);
                            mänguLava.setScene(caesariStseen);
                            tagasi.setOnMouseClicked(event_tagasi_esimesse_tuppa -> mänguLava.setScene(tuba1Stseen)); // Minnakse tagasi esimese toa stseeni

                        });
                    });
            });
            });
            peaLava.hide();
            mänguLava.setOnCloseRequest(event_mäng_kinni -> { // Kui mänguaken suletakse, siis naastakse menüüakna juurde
                peaLava.show();
            });
            mänguLava.show(); // Näidatakse mängu lava
        });

        // SISSEJUHATUS
        // SISSEJUHATUS
        nupp2.setOnMouseClicked(event_sissejuhatus -> { // Avatakse sissejuhatuse aken
            StackPane sissejuhatus = new StackPane();
            sissejuhatus.setPadding(new Insets(30, 60, 60, 60));
            // Pildi allikas: https://thedesignest.net/wp-content/uploads/2019/06/Old-Wood-Background.jpg
            BackgroundImage sissejuhatusPilt = new BackgroundImage(new Image("file:puitfailina.jpg", 923, 566, true, true),
                    BackgroundRepeat.NO_REPEAT, BackgroundRepeat.NO_REPEAT, BackgroundPosition.CENTER,
                    BackgroundSize.DEFAULT);
            sissejuhatus.setBackground(new Background(sissejuhatusPilt));
            Scene sissejuhatusStseen = new Scene(sissejuhatus, 725, 483);
            Stage sjLava = new Stage();
            sjLava.setScene(sissejuhatusStseen);
            sjLava.setTitle("Sissejuhatus");
            sjLava.setMaxWidth(725);
            sjLava.setMaxHeight(483);
            // Luuakse poolläbipaistev taust teksti jaoks ja sinna peale paigutatakse tekst
            Label sissejuhatusTekst = new Label ("Tere tulemast meie põgenemistuppa, mis on veel arendamisjärgus! \nTäname, et olete valmis mängu proovima ja sellele tagasisidet andma! \n\nPõgenemistuba on valminud TÜ kursuse Objektorienteeritud \nProgrammeerimine raames, koodi kirjutamisel on osaliselt \nkasutatud opensource-koode ning kursusel õpitud \nmaterjalidest leitud koodijuppe! \n\nMängusisene info on ise koostatud ning kõik kasutatav meedia on\ncopyright-õiguste poolelt lubatud kasutada vabavarana, seni kuni on \nviidatud algallikale - algallikad on koodi seest leitavad! \n\nProjekti autorid on Teele Tars ja Riko Piirisild! \nTagasisidet ootame sotsiaalmeediasse. \nSoovime lahedat mängukogemust!");
            sissejuhatusTekst.setFont(Font.font("Verdana", 15));
            sissejuhatusTekst.setPadding(new Insets(20,20,20,20));
            Label tekstikast = new Label();
            tekstikast.setPadding(new Insets(20,20,20,20));
            tekstikast.setPrefSize(695,470);
            tekstikast.setStyle("-fx-background-color: #FFF5EE");
            tekstikast.setOpacity(0.7);
            sissejuhatus.getChildren().addAll(tekstikast, sissejuhatusTekst);
            sjLava.show(); // Näidatakse sissejuhatuse lava
        });

        // VÄLJU
        nupp3.setOnMouseClicked(event_programm_kinni -> peaLava.hide()); // Programm pannakse kinni, kui vajutada kolmandat nuppu

        Scene stseen1 = new Scene(juur);  // luuakse stseen
        peaLava.setTitle("Põgenemistuba - Menüü");  // lava tiitelribale pannakse tekst
        peaLava.setResizable(true);
        // menüü lavale seatakse maksimaalsed mõõtmed
        peaLava.setMaxWidth(1015);
        peaLava.setMaxHeight(571);
        peaLava.setScene(stseen1);  // lavale lisatakse stseen
        peaLava.show();  // lava tehakse nähtavaks

    }
    public static int lisaFaili(long lõpphetk, long algushetk) {
        // Meetod mängija aja lisamiseks edetabelisse ja koha välja selgitamiseks
        int koht = 0;
        // Kõigepealt lisatakse mängija aeg faili
        try (BufferedWriter bw = new BufferedWriter(new FileWriter("tulemused.txt", true))) {
            bw.write(String.valueOf(lõpphetk-algushetk));
            bw.newLine();
        } catch (IOException e) { // Kui tekib viga, siis mängijat teavitatakse sellest
            System.out.println("Kahjuks ebaõnnestus edetabelisse lisamine.");
        }
        // Seejärel loetakse failist kõik read ja koostatakse neist list
        try(BufferedReader br = new BufferedReader(new FileReader("tulemused.txt"))){
            String rida = br.readLine();
            List<Long> tulemused = new ArrayList<>();
            while(rida != null){
                tulemused.add(Long.parseLong(rida));
                rida = br.readLine();
            }
            // List sorteeritakse kasvavalt
            tulemused.sort(Comparator.naturalOrder());
            for (int i = 0; i < tulemused.size(); i++) {
                if (tulemused.get(i) == lõpphetk-algushetk){
                    // Leitakse mängija koht järjestuses
                    koht = i + 1;
                    break;
                }
            }
        } catch (IOException e){ // Kui tekib viga, siis mängijat teavitatakse sellest
            System.out.println("Kahjuks ebaõnnestus edetabelisse lisamine.");
        }
        return koht; // mängija koht tagastakse
    }
}